#include "game.h"
#include <time.h>
#include <stdlib.h>
#include <string.h>

#define MAX_RAND_TRIES_PER_WORD 10
#define EMPTY_CHAR 0

//TODO: Spiellogik implementieren:
/* * Wörter aus der Wortliste zufällig horizontal oder vertikal platzieren
   * restliche Felder mit zufälligen Buchstaben füllen */

// Creates the word salad by placing words randomly and filling empty spaces
int createWordSalad(char salad[MAX_SEARCH_FIELD_LEN][MAX_SEARCH_FIELD_LEN], unsigned int searchFieldLen, const char words[][MAX_WORD_LEN], unsigned int wordCount)
{
   srand(time(NULL));
   unsigned int placedWordsCount = 0;
   //salad = spielfeld (100*100)
   //searchFieldLen = salad Size = 20
   //words = array mit den zu plazierenden wörtern
   //anzahl an zu plazierenden wörtern
   const char buchstaben[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
   const int anzahlBuchstaben = 26;

   for (int i = 0; i < wordCount; i++) {
      typedef enum {VERTIKAL, HORIZONTAL} Richtung;
      Richtung vertikal_horizontal = rand() % 2; //1 = vertikal //0 = horizontal
      int leange = strlen(words[i]);
      int positionX = 0;
      int positionY = 0;
      int voll = 0;
      int tries = 0;

      if (vertikal_horizontal == VERTIKAL) {

         tries = 0;
         do {
            voll = 0;
            positionX = rand() % (searchFieldLen);
            positionY = rand() % (searchFieldLen-leange);
            for(int j = positionY; j < positionY+leange ; j++) { //überprüfung ob alle positionen 0 sind
               if(salad[j][positionX] != '0') {
                  voll = 1;
               }
            }
            tries++;
         } while (voll == 1 && tries <= MAX_RAND_TRIES_PER_WORD);
         if (voll == 0) {
            for(int k = positionY, l = 0; k < positionY+leange; k++, l++) { //buchstaben holen und setzen
               salad[k][positionX] = words[i][l];
            }
            placedWordsCount++;
         } else if (voll == 1)
            printf("Das Wort '%s' konnte nicht plaziert werden", words[i]);
   
      } else if (vertikal_horizontal == HORIZONTAL) {

         tries = 0;
         do {
            voll = 0;
            positionY = rand() % (searchFieldLen);
            positionX = rand() % (searchFieldLen-leange);
            for(int j = positionX; j < positionX+leange ; j++) { //überprüfung ob alle positionen 0 sind
               if(salad[positionY][j] != '0') {
                  voll = 1;
               }
            }
            tries++;
         } while (voll == 1 && tries <= MAX_RAND_TRIES_PER_WORD);
         if (voll == 0) {
            for(int k = positionX, l = 0; k < positionX+leange; k++, l++) { //buchstaben holen und setzen
               salad[positionY][k] = words[i][l];
            }
            placedWordsCount++;
         } else if (voll == 1)
            printf("Das Wort '%s' konnte nicht plaziert werden", words[i]);

      } else
         printf("Fehler bei Vertikal Horizontal Wert: %d", vertikal_horizontal);
   }

   for(int i = 0; i < searchFieldLen; i++) {
      for(int j = 0; j < searchFieldLen; j++) {
         if(salad[i][j] == '0') {
            salad[i][j] = buchstaben[rand() % anzahlBuchstaben];
         }
      }
   }

   return placedWordsCount;

}

// Prints the word salad to console
void showWordSalad(const char salad[MAX_SEARCH_FIELD_LEN][MAX_SEARCH_FIELD_LEN], unsigned int searchFieldLen)
{
   for(int i = 0; i < searchFieldLen; i++) {
      for(int j = 0; j < searchFieldLen; j++) {
         printf(" %c", salad[i][j]);
      }
      printf("\n");
   }

}
